## libsemanage 3.5

=== debian/changelog ===
libsemanage (3.5-1deepin1) unstable; urgency=medium

  * No source change upload against python 3.12.

 -- Tianyu Chen <sweetyfish@deepin.org>  Mon, 08 Jul 2024 09:51:41 +0200

libsemanage (3.5-1) unstable; urgency=medium

  [ Laurent Bigonville ]
  * New upstream release
    - debian/rules: Properly set the install layout for the python module
    - debian/control: Bump {build-}dependencies to match new release
  * debian/upstream/signing-key.asc: Add public key of Jason Zaman
  * debian/control: Bump Standards-Version to 4.6.2 (no further changes)
  * debian/control: Drop ancient Breaks/Replaces
  * debian/control: Drop dependency against ruby | ruby-interpreter, to please
    lintian

  [ Helmut Grohne ]
  * Fix FTCBFS: Support cross building python and ruby extensions.
    (Closes: #1022967)

  [ Bastian Germann ]
  * Fix "Inaccurate copyright file" (Closes: #1031797)

 -- Laurent Bigonville <bigon@debian.org>  Mon, 10 Jul 2023 20:43:07 +0200

=== debian/control ===
Source: libsemanage
Vcs-Git: https://salsa.debian.org/selinux-team/libsemanage.git
Vcs-Browser: https://salsa.debian.org/selinux-team/libsemanage
Priority: optional
Section: libdevel
Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
Uploaders: Laurent Bigonville <bigon@debian.org>,
           Russell Coker <russell@coker.com.au>
Standards-Version: 4.6.2
Build-Depends: bison,
               debhelper-compat (= 13),
               dh-sequence-python3 <!nopython>,
               dh-sequence-ruby <!noruby>,
               file,
               flex,
               gem2deb (>= 0.5.0~) <!noruby>,
               libaudit-dev,
               libbz2-dev,
               libcunit1-dev <!nocheck>,
               libpython3-all-dev <!nopython>,
               libselinux1-dev (>= 3.5),
               libsepol-dev (>= 3.5),
               pkg-config,
               python3-all-dev:any <!nopython>,
               secilc (>= 3.5) <!nocheck>,
               swig <!nopython> <!noruby>
Homepage: https://selinuxproject.org
XS-Ruby-Versions: all
Rules-Requires-Root: no

Package: libsemanage-common
Architecture: all
Section: libs
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Common files for SELinux policy management libraries
 This package provides the common files used by the shared libraries
 for SELinux policy management.
 .
 Security-enhanced Linux is a patch of the Linux kernel and a
 number of utilities with enhanced security functionality designed to
 add mandatory access controls to Linux.  The Security-enhanced Linux
 kernel contains new architectural components originally developed to
 improve the security of the Flask operating system. These
 architectural components provide general support for the enforcement
 of many kinds of mandatory access control policies, including those
 based on the concepts of Type Enforcement, Role-based Access
 Control, and Multi-level Security.

Package: libsemanage2
Architecture: linux-any
Section: libs
Depends: libsemanage-common (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: SELinux policy management library
 This package provides the shared libraries for SELinux policy management.
 It uses libsepol for binary policy manipulation and libselinux for
 interacting with the SELinux system.  It also exec's helper programs
 for loading policy and for checking whether the file_contexts
 configuration is valid (load_policy and setfiles from
 policycoreutils) presently, although this may change at least for the
 bootstrapping case
 .
 Security-enhanced Linux is a patch of the Linux kernel and a
 number of utilities with enhanced security functionality designed to
 add mandatory access controls to Linux.  The Security-enhanced Linux
 kernel contains new architectural components originally developed to
 improve the security of the Flask operating system. These
 architectural components provide general support for the enforcement
 of many kinds of mandatory access control policies, including those
 based on the concepts of Type Enforcement, Role-based Access
 Control, and Multi-level Security.

Package: libsemanage-dev
Architecture: linux-any
Depends: libbz2-dev,
         libselinux1-dev (>= 3.5),
         libsemanage2 (= ${binary:Version}),
         libsepol-dev (>= 3.5),
         ${misc:Depends},
         ${shlibs:Depends}
Multi-Arch: same
Description: Header files and libraries for SELinux policy manipulation
 This package provides an API for the management of SELinux policies.
 It contains the static libraries and header files needed
 for developing applications that manage SELinux policies.
 .
 Security-enhanced Linux is a patch of the Linux kernel and a
 number of utilities with enhanced security functionality designed to
 add mandatory access controls to Linux.  The Security-enhanced Linux
 kernel contains new architectural components originally developed to
 improve the security of the Flask operating system. These
 architectural components provide general support for the enforcement
 of many kinds of mandatory access control policies, including those
 based on the concepts of Type Enforcement, Role-based Access
 Control, and Multi-level Security.

Package: ruby-semanage
Architecture: linux-any
Depends: ${ruby:Depends}, ${misc:Depends}, ${shlibs:Depends}
Section: ruby
Build-Profiles: <!noruby>
XB-Ruby-Versions: ${ruby:Versions}
Multi-Arch: same
Description: Ruby bindings to for SELinux policy management
 This package provides the Ruby bindings needed for developing Ruby
 applications that manage SELinux policies.
 .
 Security-enhanced Linux is a patch of the Linux kernel and a
 number of utilities with enhanced security functionality designed to
 add mandatory access controls to Linux.  The Security-enhanced Linux
 kernel contains new architectural components originally developed to
 improve the security of the Flask operating system. These
 architectural components provide general support for the enforcement
 of many kinds of mandatory access control policies, including those
 based on the concepts of Type Enforcement, Role-based Access
 Control, and Multi-level Security.

Package: python3-semanage
Architecture: linux-any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Section: python
Build-Profiles: <!nopython>
Description: Python3 bindings for SELinux policy management
 This package provides Python3 bindings for the management of SELinux
 policies.
 .
 Security-enhanced Linux is a patch of the Linux kernel and a
 number of utilities with enhanced security functionality designed to
 add mandatory access controls to Linux.  The Security-enhanced Linux
 kernel contains new architectural components originally developed to
 improve the security of the Flask operating system. These
 architectural components provide general support for the enforcement
 of many kinds of mandatory access control policies, including those
 based on the concepts of Type Enforcement, Role-based Access
 Control, and Multi-level Security.

Package: semanage-utils
Architecture: all
Depends: libsepol2 (>= 3.5),
         python3 (>= 3.2),
         python3-selinux (>= 3.5),
         python3-semanage (>= 3.5),
         ${misc:Depends},
         ${python3:Depends}
Section: admin
Description: SELinux policy management utilities
 This package contains an utility that can be used to migrate from the old
 policy store format (HLL, stored in /etc/selinux) to the new one (CLI, stored
 in /var/lib/selinux).
 .
 Security-enhanced Linux is a patch of the Linux kernel and a
 number of utilities with enhanced security functionality designed to
 add mandatory access controls to Linux.  The Security-enhanced Linux
 kernel contains new architectural components originally developed to
 improve the security of the Flask operating system. These
 architectural components provide general support for the enforcement
 of many kinds of mandatory access control policies, including those
 based on the concepts of Type Enforcement, Role-based Access
 Control, and Multi-level Security.

## libsemanage 3.7

=== debian/changelog ===
libsemanage (3.7-2.1build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 17:32:00 +0000

libsemanage (3.7-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches: Apply upstream patch to fix build with swig 4.3.0 (Closes:
    #1091109)

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 25 Jan 2025 10:00:57 +0100

libsemanage (3.7-2) unstable; urgency=medium

  * Make libsemanage-dev depend on libselinux1-dev

 -- Russell Coker <russell@coker.com.au>  Fri, 30 Aug 2024 13:44:45 +1000

libsemanage (3.7-1) unstable; urgency=medium

  * New upstream release
  * Change libsemanage-dev to depend on libselinux-dev
  * Add extra upstream signing key for Petr Lautrbach
  * Remove libsemanage-common.install line for russian man pages

 -- Russell Coker <russell@coker.com.au>  Sun, 25 Aug 2024 21:21:22 +1000

=== debian/control ===
--- 
+++ 
@@ -18,11 +18,11 @@
                libbz2-dev,
                libcunit1-dev <!nocheck>,
                libpython3-all-dev <!nopython>,
-               libselinux1-dev (>= 3.5),
-               libsepol-dev (>= 3.5),
+               libselinux1-dev (>= 3.7),
+               libsepol-dev (>= 3.7),
                pkg-config,
                python3-all-dev:any <!nopython>,
-               secilc (>= 3.5) <!nocheck>,
+               secilc (>= 3.7) <!nocheck>,
                swig <!nopython> <!noruby>
 Homepage: https://selinuxproject.org
 XS-Ruby-Versions: all
@@ -77,9 +77,9 @@
 Package: libsemanage-dev
 Architecture: linux-any
 Depends: libbz2-dev,
-         libselinux1-dev (>= 3.5),
+         libselinux1-dev (>= 3.7),
          libsemanage2 (= ${binary:Version}),
-         libsepol-dev (>= 3.5),
+         libsepol-dev (>= 3.7),
          ${misc:Depends},
          ${shlibs:Depends}
 Multi-Arch: same
@@ -140,10 +140,10 @@
 
 Package: semanage-utils
 Architecture: all
-Depends: libsepol2 (>= 3.5),
+Depends: libsepol2 (>= 3.7),
          python3 (>= 3.2),
-         python3-selinux (>= 3.5),
-         python3-semanage (>= 3.5),
+         python3-selinux (>= 3.7),
+         python3-semanage (>= 3.7),
          ${misc:Depends},
          ${python3:Depends}
 Section: admin

## libsemanage 3.8

=== debian/changelog ===
libsemanage (3.8-1) unstable; urgency=medium

  * 3.8 upstream release

 -- Russell Coker <russell@coker.com.au>  Thu, 06 Feb 2025 22:57:00 +1100

=== debian/control ===
--- 
+++ 
@@ -18,11 +18,11 @@
                libbz2-dev,
                libcunit1-dev <!nocheck>,
                libpython3-all-dev <!nopython>,
-               libselinux1-dev (>= 3.7),
-               libsepol-dev (>= 3.7),
+               libselinux1-dev (>= 3.8),
+               libsepol-dev (>= 3.8),
                pkg-config,
                python3-all-dev:any <!nopython>,
-               secilc (>= 3.7) <!nocheck>,
+               secilc (>= 3.8) <!nocheck>,
                swig <!nopython> <!noruby>
 Homepage: https://selinuxproject.org
 XS-Ruby-Versions: all
@@ -77,9 +77,9 @@
 Package: libsemanage-dev
 Architecture: linux-any
 Depends: libbz2-dev,
-         libselinux1-dev (>= 3.7),
+         libselinux1-dev (>= 3.8),
          libsemanage2 (= ${binary:Version}),
-         libsepol-dev (>= 3.7),
+         libsepol-dev (>= 3.8),
          ${misc:Depends},
          ${shlibs:Depends}
 Multi-Arch: same
@@ -140,10 +140,10 @@
 
 Package: semanage-utils
 Architecture: all
-Depends: libsepol2 (>= 3.7),
+Depends: libsepol2 (>= 3.8),
          python3 (>= 3.2),
-         python3-selinux (>= 3.7),
-         python3-semanage (>= 3.7),
+         python3-selinux (>= 3.8),
+         python3-semanage (>= 3.8),
          ${misc:Depends},
          ${python3:Depends}
 Section: admin

## libsemanage 3.8.1

=== debian/changelog ===
libsemanage (3.8.1-1build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 19 Oct 2025 12:02:19 +0000

libsemanage (3.8.1-1) unstable; urgency=medium

  * 3.8.1 upstream release, performance fix
  * Add patch for semanage.conf(5) from Bjarni Ingi Gislason
    Close: #950196  Close: #1096015

 -- Russell Coker <russell@coker.com.au>  Sun, 16 Mar 2025 18:46:12 +1100

=== debian/control ===
--- 
+++ 
@@ -18,11 +18,11 @@
                libbz2-dev,
                libcunit1-dev <!nocheck>,
                libpython3-all-dev <!nopython>,
-               libselinux1-dev (>= 3.8),
-               libsepol-dev (>= 3.8),
+               libselinux1-dev (>= 3.8.1),
+               libsepol-dev (>= 3.8.1),
                pkg-config,
                python3-all-dev:any <!nopython>,
-               secilc (>= 3.8) <!nocheck>,
+               secilc (>= 3.8.1) <!nocheck>,
                swig <!nopython> <!noruby>
 Homepage: https://selinuxproject.org
 XS-Ruby-Versions: all
@@ -77,9 +77,9 @@
 Package: libsemanage-dev
 Architecture: linux-any
 Depends: libbz2-dev,
-         libselinux1-dev (>= 3.8),
+         libselinux1-dev (>= 3.8.1),
          libsemanage2 (= ${binary:Version}),
-         libsepol-dev (>= 3.8),
+         libsepol-dev (>= 3.8.1),
          ${misc:Depends},
          ${shlibs:Depends}
 Multi-Arch: same
@@ -140,10 +140,10 @@
 
 Package: semanage-utils
 Architecture: all
-Depends: libsepol2 (>= 3.8),
+Depends: libsepol2 (>= 3.8.1),
          python3 (>= 3.2),
-         python3-selinux (>= 3.8),
-         python3-semanage (>= 3.8),
+         python3-selinux (>= 3.8.1),
+         python3-semanage (>= 3.8.1),
          ${misc:Depends},
          ${python3:Depends}
 Section: admin

## libsemanage 3.9

=== Makefile ===
all:
	$(MAKE) -C src all

swigify:
	$(MAKE) -C src swigify

pywrap:
	$(MAKE) -C src pywrap

rubywrap:
	$(MAKE) -C src rubywrap

install:
	$(MAKE) -C include install
	$(MAKE) -C src install
	$(MAKE) -C man install
	$(MAKE) -C utils install

install-pywrap:
	$(MAKE) -C src install-pywrap

install-rubywrap:
	$(MAKE) -C src install-rubywrap

relabel:
	$(MAKE) -C src relabel

clean distclean:
	$(MAKE) -C src $@
	$(MAKE) -C tests $@

indent:
	$(MAKE) -C src $@
	$(MAKE) -C include $@

test: all
	$(MAKE) -C tests test

=== include/Makefile ===
# Installation directories.
PREFIX ?= /usr
INCDIR ?= $(PREFIX)/include/semanage

all:

install: all
	test -d $(DESTDIR)$(INCDIR) || install -m 755 -d $(DESTDIR)$(INCDIR)
	install -m 644 $(wildcard semanage/*.h) $(DESTDIR)$(INCDIR)

indent:
	../../scripts/Lindent $(wildcard semanage/*.h)

=== man/Makefile ===
# Installation directories.
LINGUAS ?=
PREFIX ?= /usr
MANDIR ?=  $(PREFIX)/share/man
MAN3SUBDIR ?= man3
MAN5SUBDIR ?= man5
MAN3DIR ?= $(MANDIR)/$(MAN3SUBDIR)
MAN5DIR ?= $(MANDIR)/$(MAN5SUBDIR)

all:

install: all
	mkdir -p $(DESTDIR)$(MAN3DIR)
	mkdir -p $(DESTDIR)$(MAN5DIR)
	install -m 644 man3/*.3 $(DESTDIR)$(MAN3DIR)
	install -m 644 man5/*.5 $(DESTDIR)$(MAN5DIR)
	for lang in $(LINGUAS) ; do \
		if [ -e $${lang}/man3 ] ; then \
			mkdir -p $(DESTDIR)$(MANDIR)/$${lang}/$(MAN3SUBDIR) ; \
			install -m 644 $${lang}/man3/*.3 $(DESTDIR)$(MANDIR)/$${lang}/$(MAN3SUBDIR) ; \
		fi ; \
		if [ -e $${lang}/man5 ] ; then \
			mkdir -p $(DESTDIR)$(MANDIR)/$${lang}/$(MAN5SUBDIR) ; \
			install -m 644 $${lang}/man5/*.5 $(DESTDIR)$(MANDIR)/$${lang}/$(MAN5SUBDIR) ; \
		fi ; \
	done

=== src/Makefile ===
# Support building the Python bindings multiple times, against various Python
# runtimes (e.g. Python 2 vs Python 3) by optionally prefixing the build
# targets with "PYPREFIX":
PYTHON ?= python3
PYPREFIX ?= $(shell $(PYTHON) -c 'import sys;print("python-%d.%d" % sys.version_info[:2])')
RUBY ?= ruby
RUBYPREFIX ?= $(notdir $(RUBY))
PKG_CONFIG ?= pkg-config

# Installation directories.
PREFIX ?= /usr
LIBDIR ?= $(PREFIX)/lib
INCLUDEDIR ?= $(PREFIX)/include
SYSCONFDIR ?= /etc
PYINC ?= $(shell $(PKG_CONFIG) --cflags $(PYPREFIX))
PYLIBS ?= $(shell $(PKG_CONFIG) --libs $(PYPREFIX))
PYTHONLIBDIR ?= $(shell $(PYTHON) -c "import sysconfig; print(sysconfig.get_path('platlib', vars={'platbase': '$(PREFIX)', 'base': '$(PREFIX)'}))")
PYCEXT ?= $(shell $(PYTHON) -c 'import importlib.machinery;print(importlib.machinery.EXTENSION_SUFFIXES[0])')
RUBYINC ?= $(shell $(RUBY) -e 'puts "-I" + RbConfig::CONFIG["rubyarchhdrdir"] + " -I" + RbConfig::CONFIG["rubyhdrdir"]')
RUBYLIBS ?= $(shell $(RUBY) -e 'puts "-L" + RbConfig::CONFIG["libdir"] + " -L" + RbConfig::CONFIG["archlibdir"] + " " + RbConfig::CONFIG["LIBRUBYARG_SHARED"]')
RUBYINSTALL ?= $(shell $(RUBY) -e 'puts RbConfig::CONFIG["vendorarchdir"]')

DEFAULT_SEMANAGE_CONF_LOCATION=$(SYSCONFDIR)/selinux/semanage.conf

ifeq ($(DEBUG),1)
	export CFLAGS ?= -g3 -O0 -gdwarf-2 -fno-strict-aliasing -Wall -Wshadow -Werror
	export LDFLAGS ?= -g
endif

LEX = flex
LFLAGS = -s
YACC = bison
YFLAGS = -d

VERSION = $(shell cat ../VERSION)
LIBVERSION = 2

LIBA=libsemanage.a
TARGET=libsemanage.so
LIBPC=libsemanage.pc
SWIGIF= semanageswig_python.i semanageswig_python_exception.i
SWIGRUBYIF= semanageswig_ruby.i
SWIGCOUT= semanageswig_wrap.c
SWIGRUBYCOUT= semanageswig_ruby_wrap.c
SWIGLOBJ:= $(patsubst %.c,$(PYPREFIX)%.lo,$(SWIGCOUT))
SWIGRUBYLOBJ:= $(patsubst %.c,$(RUBYPREFIX)%.lo,$(SWIGRUBYCOUT))
SWIGSO=$(PYPREFIX)_semanage.so
SWIGFILES=$(SWIGSO) semanage.py
SWIGRUBYSO=$(RUBYPREFIX)_semanage.so
LIBSO=$(TARGET).$(LIBVERSION)

GENERATED=$(SWIGCOUT) $(SWIGRUBYCOUT) semanageswig_python_exception.i $(sort $(wildcard conf-*.[ch]))
SRCS= $(filter-out $(GENERATED),$(sort $(wildcard *.c)))

OBJS= $(patsubst %.c,%.o,$(SRCS)) conf-scan.o conf-parse.o
LOBJS= $(patsubst %.c,%.lo,$(SRCS)) conf-scan.lo conf-parse.lo
CFLAGS ?= -Werror -Wall -W -Wundef -Wshadow -Wmissing-noreturn -Wmissing-format-attribute \
	  -fno-semantic-interposition

SWIG_CFLAGS += -Wno-error -Wno-unused-but-set-variable -Wno-unused-variable -Wno-shadow \
		-Wno-unused-parameter -Wno-missing-prototypes -Wno-missing-field-initializers

override CFLAGS += -I../include -I../../libselinux/include -D_GNU_SOURCE
RANLIB ?= ranlib

SWIG = swig -Wall -python -o $(SWIGCOUT) -outdir ./

SWIGRUBY = swig -Wall -ruby -o $(SWIGRUBYCOUT) -outdir ./

all: $(LIBA) $(LIBPC)
ifneq ($(DISABLE_SHARED),y)
all: $(LIBSO)
endif

pywrap: all $(SWIGSO)

rubywrap: all $(SWIGRUBYSO)

$(SWIGLOBJ): $(SWIGCOUT)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(SWIG_CFLAGS) $(PYINC) -fPIC -DSHARED -c -o $@ $<

$(SWIGRUBYLOBJ): $(SWIGRUBYCOUT)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(SWIG_CFLAGS) $(RUBYINC) -fPIC -DSHARED -c -o $@ $<

$(SWIGSO): $(SWIGLOBJ)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -L. -shared -o $@ $< -lsemanage $(PYLIBS)

$(SWIGRUBYSO): $(SWIGRUBYLOBJ)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -L. -shared -o $@ $^ -lsemanage $(RUBYLIBS)

$(LIBA): $(OBJS)
	$(AR) rcs $@ $^
	$(RANLIB) $@

$(LIBSO): $(LOBJS)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -L../../libselinux/src -lsepol -laudit -lselinux -lbz2 -Wl,-soname,$(LIBSO),--version-script=libsemanage.map,-z,defs
	ln -sf $@ $(TARGET)

$(LIBPC): $(LIBPC).in ../VERSION
	sed -e 's/@VERSION@/$(VERSION)/; s:@prefix@:$(PREFIX):; s:@libdir@:$(LIBDIR):; s:@includedir@:$(INCLUDEDIR):' < $< > $@

semanageswig_python_exception.i: exception.sh $(wildcard ../include/semanage/*.h)
	bash -e exception.sh > $@ || (rm -f $@ ; false)

conf-scan.c: conf-scan.l conf-parse.h
	$(LEX) $(LFLAGS) -o $@ $<

conf-parse.c: conf-parse.y
	$(YACC) $(YFLAGS) -o $@ $<

conf-parse.h: conf-parse.c

%.o:  %.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $<

%.lo:  %.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -fPIC -DSHARED -c -o $@ $<

conf-parse.o:  conf-parse.c
	$(CC) $(filter-out -Werror, $(CPPFLAGS) $(CFLAGS)) -c -o $@ $<

conf-parse.lo:  conf-parse.c
	$(CC) $(filter-out -Werror, $(CPPFLAGS) $(CFLAGS)) -fPIC -DSHARED -c -o $@ $<

conf-scan.o:  conf-scan.c
	$(CC) $(filter-out -Werror, $(CPPFLAGS) $(CFLAGS)) -c -o $@ $<

conf-scan.lo:  conf-scan.c
	$(CC) $(filter-out -Werror, $(CPPFLAGS) $(CFLAGS)) -fPIC -DSHARED -c -o $@ $<

$(SWIGCOUT): $(SWIGIF)
	$(SWIG) $<

$(SWIGRUBYCOUT): $(SWIGRUBYIF)
	$(SWIGRUBY) $<

swigify: $(SWIGIF)
	$(SWIG) $<

install: all
	test -d $(DESTDIR)$(LIBDIR) || install -m 755 -d $(DESTDIR)$(LIBDIR)
	install -m 644 $(LIBA) $(DESTDIR)$(LIBDIR)
	test -d $(DESTDIR)$(LIBDIR)/pkgconfig || install -m 755 -d $(DESTDIR)$(LIBDIR)/pkgconfig
	install -m 644 $(LIBPC) $(DESTDIR)$(LIBDIR)/pkgconfig
	test -f $(DESTDIR)$(DEFAULT_SEMANAGE_CONF_LOCATION) || install -m 644 -D semanage.conf $(DESTDIR)$(DEFAULT_SEMANAGE_CONF_LOCATION)
ifneq ($(DISABLE_SHARED),y)
	install -m 755 $(LIBSO) $(DESTDIR)$(LIBDIR)
	cd $(DESTDIR)$(LIBDIR) && ln -sf $(LIBSO) $(TARGET)
endif

install-pywrap: pywrap
	test -d $(DESTDIR)$(PYTHONLIBDIR) || install -m 755 -d $(DESTDIR)$(PYTHONLIBDIR)
	install -m 755 $(SWIGSO) $(DESTDIR)$(PYTHONLIBDIR)/_semanage$(PYCEXT)
	install -m 644 semanage.py $(DESTDIR)$(PYTHONLIBDIR)


install-rubywrap: rubywrap
	test -d $(DESTDIR)$(RUBYINSTALL) || install -m 755 -d $(DESTDIR)$(RUBYINSTALL)
	install -m 755 $(SWIGRUBYSO) $(DESTDIR)$(RUBYINSTALL)/semanage.so

relabel:
	/sbin/restorecon $(DESTDIR)$(LIBDIR)/$(LIBSO)

clean:
	-rm -f $(LIBPC) $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(SWIGLOBJ) $(SWIGSO) $(SWIGRUBYSO) $(TARGET) conf-parse.c conf-parse.h conf-scan.c *.o *.lo *~

distclean: clean
	rm -f $(GENERATED) $(SWIGFILES)

indent:
	../../scripts/Lindent $(filter-out $(GENERATED),$(wildcard *.[ch]))

.PHONY: all clean pywrap rubywrap swigify install install-pywrap install-rubywrap distclean

=== tests/Makefile ===
# Add your test source files here:
SOURCES = $(sort $(wildcard *.c))
CILS = $(sort $(wildcard *.cil))

###########################################################################

EXECUTABLE = libsemanage-tests
CFLAGS += -g -O0 -Wall -W -Wundef -Wmissing-noreturn -Wmissing-format-attribute
override CFLAGS += -I../src -I../include
override LDLIBS += -lcunit -lbz2 -laudit -lselinux -lsepol

OBJECTS = $(SOURCES:.c=.o)
POLICIES = $(CILS:.cil=.policy)

all: $(EXECUTABLE) $(POLICIES)

$(EXECUTABLE): $(OBJECTS) ../src/libsemanage.a
	$(CC) $(LDFLAGS) -o $@ $^ $(LDLIBS)

%.policy: %.cil
	../../secilc/secilc $*.cil -o $*.policy -f /dev/null

clean distclean:
	rm -rf $(OBJECTS) $(POLICIES) $(EXECUTABLE)

test: all
	./$(EXECUTABLE)

=== utils/Makefile ===
# Installation directories.
PREFIX ?= /usr
LIBEXECDIR ?= $(PREFIX)/libexec
SELINUXEXECDIR ?= $(LIBEXECDIR)/selinux/

all:

install: all
	-mkdir -p $(DESTDIR)$(SELINUXEXECDIR)
	install -m 755 semanage_migrate_store $(DESTDIR)$(SELINUXEXECDIR)

clean:

distclean: clean

indent:

relabel:

=== debian/changelog ===
libsemanage (3.9-1) unstable; urgency=medium

  * 3.9 upstream release
  * Merged patch for semanage.conf.5 Closes: #950196

 -- Russell Coker <russell@coker.com.au>  Sat, 18 Oct 2025 18:57:29 +1100

=== debian/control ===
--- 
+++ 
@@ -18,11 +18,11 @@
                libbz2-dev,
                libcunit1-dev <!nocheck>,
                libpython3-all-dev <!nopython>,
-               libselinux1-dev (>= 3.8.1),
-               libsepol-dev (>= 3.8.1),
+               libselinux1-dev (>= 3.9),
+               libsepol-dev (>= 3.9),
                pkg-config,
                python3-all-dev:any <!nopython>,
-               secilc (>= 3.8.1) <!nocheck>,
+               secilc (>= 3.9) <!nocheck>,
                swig <!nopython> <!noruby>
 Homepage: https://selinuxproject.org
 XS-Ruby-Versions: all
@@ -77,9 +77,9 @@
 Package: libsemanage-dev
 Architecture: linux-any
 Depends: libbz2-dev,
-         libselinux1-dev (>= 3.8.1),
+         libselinux1-dev (>= 3.9),
          libsemanage2 (= ${binary:Version}),
-         libsepol-dev (>= 3.8.1),
+         libsepol-dev (>= 3.9),
          ${misc:Depends},
          ${shlibs:Depends}
 Multi-Arch: same
@@ -140,10 +140,10 @@
 
 Package: semanage-utils
 Architecture: all
-Depends: libsepol2 (>= 3.8.1),
-         python3 (>= 3.2),
-         python3-selinux (>= 3.8.1),
-         python3-semanage (>= 3.8.1),
+Depends: libsepol2 (>= 3.9),
+         python3 (>= 3.13),
+         python3-selinux (>= 3.9),
+         python3-semanage (>= 3.9),
          ${misc:Depends},
          ${python3:Depends}
 Section: admin

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk
# for cross compilation
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
export CC := $(DEB_HOST_GNU_TYPE)-gcc
export PKG_CONFIG := $(DEB_HOST_GNU_TYPE)-pkg-config
export _PYTHON_SYSCONFIGDATA_NAME=_sysconfigdata__$(DEB_HOST_MULTIARCH)
define ruby_env
  RUBYLIB=/usr/lib/$(DEB_HOST_MULTIARCH)/ruby-crossbuild/$$($(1) -e "puts RbConfig::CONFIG['ruby_version']")
endef
else
define ruby_env
endef
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif

DOPACKAGES = $(shell dh_listpackages)

ifneq ($(filter python3-semanage,$(DOPACKAGES)),)
PY3VERSIONS = $(shell py3versions -rv)
endif
ifneq ($(filter ruby-semanage,$(DOPACKAGES)),)
RUBY_VERSIONS := $(shell dh_ruby --print-supported)
endif

# Upstream recommends using this flag
export DEB_CFLAGS_MAINT_APPEND = -fno-semantic-interposition
# The build system doesn't use CPPFLAGS, pass them to CFLAGS to enable the
# missing (hardening) flags. Also enable Wall and Wextra to spot basic irregularities.
export DEB_CFLAGS_MAINT_APPEND += $(shell dpkg-buildflags --get CPPFLAGS) -Wall -Wextra

%:
	dh $@

override_dh_auto_build:
	$(MAKE) all

ifneq ($(filter python3-semanage,$(DOPACKAGES)),)
	set -e; for version in $(PY3VERSIONS); do        \
	  $(MAKE) pywrap PYTHON=python$$version PYLIBS=; \
	done;
endif
ifneq ($(filter ruby-semanage,$(DOPACKAGES)),)
	set -e; for version in $(RUBY_VERSIONS); do      \
	  $(call ruby_env,$$version) \
	  $(MAKE) -C src rubywrap RUBY=$$version; \
	done;
endif

override_dh_auto_install:
	$(MAKE) install DESTDIR="${CURDIR}/debian/tmp" \
	  LIBDIR="/usr/lib/${DEB_HOST_MULTIARCH}" \
	  SHLIBDIR="/usr/lib/${DEB_HOST_MULTIARCH}"

ifneq ($(filter python3-semanage,$(DOPACKAGES)),)
	set -e; for version in $(PY3VERSIONS); do        \
	  $(MAKE) install-pywrap PYTHON=python$$version DESTDIR="${CURDIR}/debian/tmp" DEB_PYTHON_INSTALL_LAYOUT=deb; \
	done;
endif
ifneq ($(filter ruby-semanage,$(DOPACKAGES)),)
	set -e; for version in $(RUBY_VERSIONS); do      \
	  $(call ruby_env,$$version) \
	  $(MAKE) -C src install-rubywrap RUBY=$$version DESTDIR="${CURDIR}/debian/tmp"; \
	done;
endif

override_dh_auto_clean:
	dh_auto_clean
ifneq ($(filter python3-semanage,$(DOPACKAGES)),)
	set -e; for version in $(PY3VERSIONS); do         \
	  $(MAKE) clean PYTHON=python$$version;  \
	done;
endif
ifneq ($(filter ruby-semanage,$(DOPACKAGES)),)
	set -e; for version in $(RUBY_VERSIONS); do      \
	  $(call ruby_env,$$version) \
	  $(MAKE) clean RUBY=$$version; \
	done;
endif

override_dh_fixperms:
	dh_fixperms
ifneq ($(filter python3-semanage,$(DOPACKAGES)),)
	chmod -x ${CURDIR}/debian/python3-semanage/usr/lib/python*/*-packages/semanage.py
endif
